## ros-rolling-osqp-vendor 0.0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

project(osqp_vendor)

find_package(ament_cmake REQUIRED)

macro(build_osqp)
  set(git_tag "v0.6.2")
  set(extra_cmake_args)

  get_property(multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
  if(NOT multi_config AND DEFINED CMAKE_BUILD_TYPE)
    list(APPEND extra_cmake_args -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})
  endif()

  include(ExternalProject)
  externalproject_add(osqp-${git_tag}
    GIT_REPOSITORY https://github.com/oxfordcontrol/osqp.git
    GIT_TAG ${git_tag}
    GIT_SHALLOW ON
    TIMEOUT 60
    # Suppress git update due to https://gitlab.kitware.com/cmake/cmake/-/issues/16419
    UPDATE_COMMAND ""
    CMAKE_ARGS
      -DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/osqp_install
      ${extra_cmake_args}
  )

  # The external project will install to the build folder, but we'll install that on make install.
  install(
    DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/osqp_install/
    DESTINATION
      ${CMAKE_INSTALL_PREFIX}
    USE_SOURCE_PERMISSIONS
    PATTERN config.h EXCLUDE
  )
endmacro()

build_osqp()

ament_export_libraries(osqp)
ament_export_dependencies(osqp)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package(CONFIG_EXTRAS osqp_vendor-extras.cmake)

=== debian/changelog ===
ros-rolling-osqp-vendor (0.0.4-1focal) focal; urgency=high

  * Suppress update of pinned git repository (#8 <https://github.com/tier4/osqp_vendor/issues/8>)
    The source at that ref will never change, so there is no need to try to
    update it. This will avoid unnecessary invalidation of the build and
    install targets for the external project.
  * Always preserve source permissions in vendor packages (#7 <https://github.com/tier4/osqp_vendor/issues/7>)
    In vendor packages where we're installing an executable, we use
    USE_SOURCE_PERMISSIONS to make sure that the executable permissions on
    the binaries are maintained when the external project's staging
    directory is recursively installed to the final installation directory.
    In most of our vendor packages, we aren't using that flag where we don't
    expect an executable binary to be installed. However, for reasons I
    won't go into here, some systems use executable permissions on shared
    object libraries as well. The linker seems to handle this on our behalf,
    but we're losing the permissions during the recursive copy operation if
    we don't use this flag.
  * Add buildtool_depend on git (#6 <https://github.com/tier4/osqp_vendor/issues/6>)
  * Update workflows (#9 <https://github.com/tier4/osqp_vendor/issues/9>)
    * Update workflows
    * Remove artifact
    * Skip tests
  * Contributors: Daisuke Nishimatsu, Scott K Logan

 -- Esteve Fernandez <esteve.fernandez@autoware.org>  Mon, 06 Dec 2021 15:00:00 -0000

ros-rolling-osqp-vendor (0.0.3-1focal) focal; urgency=high

  * Release 0.0.3
  * Merge pull request #5 <https://github.com/tier4/osqp_vendor/issues/5> from tier4/update-0.6.2
    Bump version to 0.6.2
  * Bump version to 0.6.2
  * Contributors: Esteve Fernandez

 -- Esteve Fernandez <esteve.fernandez@autoware.org>  Mon, 12 Apr 2021 15:00:00 -0000

ros-rolling-osqp-vendor (0.0.2-1focal) focal; urgency=high

  * Release 0.0.2
  * Added missing CONTRIBUTING.md
  * Contributors: Esteve Fernandez

 -- Esteve Fernandez <esteve.fernandez@autoware.org>  Tue, 03 Nov 2020 15:00:00 -0000

ros-rolling-osqp-vendor (0.0.1-1focal) focal; urgency=high

  * Update README.md
  * Removed unused BUILD_SHARED_LIBS=ON, not needed since osqp builds both shared and static libraries
  * Merge pull request #1 <https://github.com/tier4/osqp_vendor/issues/1> from tier4/vendor
    Added OSQP vendor package
  * Added OSQP vendor package
  * Initial commit
  * Contributors: Esteve Fernandez

 -- Esteve Fernandez <esteve.fernandez@autoware.org>  Sun, 18 Oct 2020 15:00:00 -0000

=== debian/control ===
Source: ros-rolling-osqp-vendor
Section: misc
Priority: optional
Maintainer: Esteve Fernandez <esteve.fernandez@autoware.org>
Build-Depends: debhelper (>= 9.0.0), git, ros-rolling-ament-cmake, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-ros-workspace
Homepage: https://github.com/oxfordcontrol/osqp
Standards-Version: 3.9.2

Package: ros-rolling-osqp-vendor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-ros-workspace
Description: Wrapper around osqp that ships with a CMake module

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-osqp-vendor//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-osqp-vendor 0.2.0

=== debian/changelog ===
ros-rolling-osqp-vendor (0.2.0-2jammy) jammy; urgency=high

  * feat: enable to build with both ros1 and ros2 (#16 <https://github.com/tier4/osqp_vendor/issues/16>)
    * feat: enable to build with both ros1 and ros2
    * fix github action
  * Contributors: Daisuke Nishimatsu

 -- Esteve Fernandez <esteve.fernandez@autoware.org>  Sun, 23 Oct 2022 07:00:00 -0000

ros-rolling-osqp-vendor (0.0.4-2jammy) jammy; urgency=high

  * Suppress update of pinned git repository (#8 <https://github.com/tier4/osqp_vendor/issues/8>)
    The source at that ref will never change, so there is no need to try to
    update it. This will avoid unnecessary invalidation of the build and
    install targets for the external project.
  * Always preserve source permissions in vendor packages (#7 <https://github.com/tier4/osqp_vendor/issues/7>)
    In vendor packages where we're installing an executable, we use
    USE_SOURCE_PERMISSIONS to make sure that the executable permissions on
    the binaries are maintained when the external project's staging
    directory is recursively installed to the final installation directory.
    In most of our vendor packages, we aren't using that flag where we don't
    expect an executable binary to be installed. However, for reasons I
    won't go into here, some systems use executable permissions on shared
    object libraries as well. The linker seems to handle this on our behalf,
    but we're losing the permissions during the recursive copy operation if
    we don't use this flag.
  * Add buildtool_depend on git (#6 <https://github.com/tier4/osqp_vendor/issues/6>)
  * Update workflows (#9 <https://github.com/tier4/osqp_vendor/issues/9>)
    * Update workflows
    * Remove artifact
    * Skip tests
  * Contributors: Daisuke Nishimatsu, Scott K Logan

 -- Esteve Fernandez <esteve.fernandez@autoware.org>  Tue, 07 Dec 2021 08:00:00 -0000

ros-rolling-osqp-vendor (0.0.3-2jammy) jammy; urgency=high

  * Release 0.0.3
  * Merge pull request #5 <https://github.com/tier4/osqp_vendor/issues/5> from tier4/update-0.6.2
    Bump version to 0.6.2
  * Bump version to 0.6.2
  * Contributors: Esteve Fernandez

 -- Esteve Fernandez <esteve.fernandez@autoware.org>  Tue, 13 Apr 2021 07:00:00 -0000

ros-rolling-osqp-vendor (0.0.2-2jammy) jammy; urgency=high

  * Release 0.0.2
  * Added missing CONTRIBUTING.md
  * Contributors: Esteve Fernandez

 -- Esteve Fernandez <esteve.fernandez@autoware.org>  Wed, 04 Nov 2020 08:00:00 -0000

ros-rolling-osqp-vendor (0.0.1-2jammy) jammy; urgency=high

  * Update README.md
  * Removed unused BUILD_SHARED_LIBS=ON, not needed since osqp builds both shared and static libraries
  * Merge pull request #1 <https://github.com/tier4/osqp_vendor/issues/1> from tier4/vendor
    Added OSQP vendor package
  * Added OSQP vendor package
  * Initial commit
  * Contributors: Esteve Fernandez

 -- Esteve Fernandez <esteve.fernandez@autoware.org>  Mon, 19 Oct 2020 07:00:00 -0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Esteve Fernandez <esteve.fernandez@autoware.org>
-Build-Depends: debhelper (>= 9.0.0), git, ros-rolling-ament-cmake, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-ros-workspace
+Build-Depends: debhelper (>= 9.0.0), git, ros-rolling-ament-cmake, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-ros-environment, ros-rolling-ros-workspace
 Homepage: https://github.com/oxfordcontrol/osqp
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
